// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from grbl_msgs:action/SendGcodeFile.idl
// generated code does not contain a copyright notice

#ifndef GRBL_MSGS__ACTION__DETAIL__SEND_GCODE_FILE__TRAITS_HPP_
#define GRBL_MSGS__ACTION__DETAIL__SEND_GCODE_FILE__TRAITS_HPP_

#include "grbl_msgs/action/detail/send_gcode_file__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const grbl_msgs::action::SendGcodeFile_Goal & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: file_path
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "file_path: ";
    value_to_yaml(msg.file_path, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const grbl_msgs::action::SendGcodeFile_Goal & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<grbl_msgs::action::SendGcodeFile_Goal>()
{
  return "grbl_msgs::action::SendGcodeFile_Goal";
}

template<>
inline const char * name<grbl_msgs::action::SendGcodeFile_Goal>()
{
  return "grbl_msgs/action/SendGcodeFile_Goal";
}

template<>
struct has_fixed_size<grbl_msgs::action::SendGcodeFile_Goal>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<grbl_msgs::action::SendGcodeFile_Goal>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<grbl_msgs::action::SendGcodeFile_Goal>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

inline void to_yaml(
  const grbl_msgs::action::SendGcodeFile_Result & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const grbl_msgs::action::SendGcodeFile_Result & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<grbl_msgs::action::SendGcodeFile_Result>()
{
  return "grbl_msgs::action::SendGcodeFile_Result";
}

template<>
inline const char * name<grbl_msgs::action::SendGcodeFile_Result>()
{
  return "grbl_msgs/action/SendGcodeFile_Result";
}

template<>
struct has_fixed_size<grbl_msgs::action::SendGcodeFile_Result>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<grbl_msgs::action::SendGcodeFile_Result>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<grbl_msgs::action::SendGcodeFile_Result>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

inline void to_yaml(
  const grbl_msgs::action::SendGcodeFile_Feedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status: ";
    value_to_yaml(msg.status, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const grbl_msgs::action::SendGcodeFile_Feedback & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<grbl_msgs::action::SendGcodeFile_Feedback>()
{
  return "grbl_msgs::action::SendGcodeFile_Feedback";
}

template<>
inline const char * name<grbl_msgs::action::SendGcodeFile_Feedback>()
{
  return "grbl_msgs/action/SendGcodeFile_Feedback";
}

template<>
struct has_fixed_size<grbl_msgs::action::SendGcodeFile_Feedback>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<grbl_msgs::action::SendGcodeFile_Feedback>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<grbl_msgs::action::SendGcodeFile_Feedback>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'goal'
#include "grbl_msgs/action/detail/send_gcode_file__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const grbl_msgs::action::SendGcodeFile_SendGoal_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_yaml(msg.goal_id, out, indentation + 2);
  }

  // member: goal
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal:\n";
    to_yaml(msg.goal, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const grbl_msgs::action::SendGcodeFile_SendGoal_Request & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<grbl_msgs::action::SendGcodeFile_SendGoal_Request>()
{
  return "grbl_msgs::action::SendGcodeFile_SendGoal_Request";
}

template<>
inline const char * name<grbl_msgs::action::SendGcodeFile_SendGoal_Request>()
{
  return "grbl_msgs/action/SendGcodeFile_SendGoal_Request";
}

template<>
struct has_fixed_size<grbl_msgs::action::SendGcodeFile_SendGoal_Request>
  : std::integral_constant<bool, has_fixed_size<grbl_msgs::action::SendGcodeFile_Goal>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<grbl_msgs::action::SendGcodeFile_SendGoal_Request>
  : std::integral_constant<bool, has_bounded_size<grbl_msgs::action::SendGcodeFile_Goal>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<grbl_msgs::action::SendGcodeFile_SendGoal_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const grbl_msgs::action::SendGcodeFile_SendGoal_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: accepted
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "accepted: ";
    value_to_yaml(msg.accepted, out);
    out << "\n";
  }

  // member: stamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stamp:\n";
    to_yaml(msg.stamp, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const grbl_msgs::action::SendGcodeFile_SendGoal_Response & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<grbl_msgs::action::SendGcodeFile_SendGoal_Response>()
{
  return "grbl_msgs::action::SendGcodeFile_SendGoal_Response";
}

template<>
inline const char * name<grbl_msgs::action::SendGcodeFile_SendGoal_Response>()
{
  return "grbl_msgs/action/SendGcodeFile_SendGoal_Response";
}

template<>
struct has_fixed_size<grbl_msgs::action::SendGcodeFile_SendGoal_Response>
  : std::integral_constant<bool, has_fixed_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct has_bounded_size<grbl_msgs::action::SendGcodeFile_SendGoal_Response>
  : std::integral_constant<bool, has_bounded_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct is_message<grbl_msgs::action::SendGcodeFile_SendGoal_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<grbl_msgs::action::SendGcodeFile_SendGoal>()
{
  return "grbl_msgs::action::SendGcodeFile_SendGoal";
}

template<>
inline const char * name<grbl_msgs::action::SendGcodeFile_SendGoal>()
{
  return "grbl_msgs/action/SendGcodeFile_SendGoal";
}

template<>
struct has_fixed_size<grbl_msgs::action::SendGcodeFile_SendGoal>
  : std::integral_constant<
    bool,
    has_fixed_size<grbl_msgs::action::SendGcodeFile_SendGoal_Request>::value &&
    has_fixed_size<grbl_msgs::action::SendGcodeFile_SendGoal_Response>::value
  >
{
};

template<>
struct has_bounded_size<grbl_msgs::action::SendGcodeFile_SendGoal>
  : std::integral_constant<
    bool,
    has_bounded_size<grbl_msgs::action::SendGcodeFile_SendGoal_Request>::value &&
    has_bounded_size<grbl_msgs::action::SendGcodeFile_SendGoal_Response>::value
  >
{
};

template<>
struct is_service<grbl_msgs::action::SendGcodeFile_SendGoal>
  : std::true_type
{
};

template<>
struct is_service_request<grbl_msgs::action::SendGcodeFile_SendGoal_Request>
  : std::true_type
{
};

template<>
struct is_service_response<grbl_msgs::action::SendGcodeFile_SendGoal_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const grbl_msgs::action::SendGcodeFile_GetResult_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_yaml(msg.goal_id, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const grbl_msgs::action::SendGcodeFile_GetResult_Request & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<grbl_msgs::action::SendGcodeFile_GetResult_Request>()
{
  return "grbl_msgs::action::SendGcodeFile_GetResult_Request";
}

template<>
inline const char * name<grbl_msgs::action::SendGcodeFile_GetResult_Request>()
{
  return "grbl_msgs/action/SendGcodeFile_GetResult_Request";
}

template<>
struct has_fixed_size<grbl_msgs::action::SendGcodeFile_GetResult_Request>
  : std::integral_constant<bool, has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<grbl_msgs::action::SendGcodeFile_GetResult_Request>
  : std::integral_constant<bool, has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<grbl_msgs::action::SendGcodeFile_GetResult_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'result'
// already included above
// #include "grbl_msgs/action/detail/send_gcode_file__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const grbl_msgs::action::SendGcodeFile_GetResult_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status: ";
    value_to_yaml(msg.status, out);
    out << "\n";
  }

  // member: result
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "result:\n";
    to_yaml(msg.result, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const grbl_msgs::action::SendGcodeFile_GetResult_Response & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<grbl_msgs::action::SendGcodeFile_GetResult_Response>()
{
  return "grbl_msgs::action::SendGcodeFile_GetResult_Response";
}

template<>
inline const char * name<grbl_msgs::action::SendGcodeFile_GetResult_Response>()
{
  return "grbl_msgs/action/SendGcodeFile_GetResult_Response";
}

template<>
struct has_fixed_size<grbl_msgs::action::SendGcodeFile_GetResult_Response>
  : std::integral_constant<bool, has_fixed_size<grbl_msgs::action::SendGcodeFile_Result>::value> {};

template<>
struct has_bounded_size<grbl_msgs::action::SendGcodeFile_GetResult_Response>
  : std::integral_constant<bool, has_bounded_size<grbl_msgs::action::SendGcodeFile_Result>::value> {};

template<>
struct is_message<grbl_msgs::action::SendGcodeFile_GetResult_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<grbl_msgs::action::SendGcodeFile_GetResult>()
{
  return "grbl_msgs::action::SendGcodeFile_GetResult";
}

template<>
inline const char * name<grbl_msgs::action::SendGcodeFile_GetResult>()
{
  return "grbl_msgs/action/SendGcodeFile_GetResult";
}

template<>
struct has_fixed_size<grbl_msgs::action::SendGcodeFile_GetResult>
  : std::integral_constant<
    bool,
    has_fixed_size<grbl_msgs::action::SendGcodeFile_GetResult_Request>::value &&
    has_fixed_size<grbl_msgs::action::SendGcodeFile_GetResult_Response>::value
  >
{
};

template<>
struct has_bounded_size<grbl_msgs::action::SendGcodeFile_GetResult>
  : std::integral_constant<
    bool,
    has_bounded_size<grbl_msgs::action::SendGcodeFile_GetResult_Request>::value &&
    has_bounded_size<grbl_msgs::action::SendGcodeFile_GetResult_Response>::value
  >
{
};

template<>
struct is_service<grbl_msgs::action::SendGcodeFile_GetResult>
  : std::true_type
{
};

template<>
struct is_service_request<grbl_msgs::action::SendGcodeFile_GetResult_Request>
  : std::true_type
{
};

template<>
struct is_service_response<grbl_msgs::action::SendGcodeFile_GetResult_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'feedback'
// already included above
// #include "grbl_msgs/action/detail/send_gcode_file__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const grbl_msgs::action::SendGcodeFile_FeedbackMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_yaml(msg.goal_id, out, indentation + 2);
  }

  // member: feedback
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "feedback:\n";
    to_yaml(msg.feedback, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const grbl_msgs::action::SendGcodeFile_FeedbackMessage & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<grbl_msgs::action::SendGcodeFile_FeedbackMessage>()
{
  return "grbl_msgs::action::SendGcodeFile_FeedbackMessage";
}

template<>
inline const char * name<grbl_msgs::action::SendGcodeFile_FeedbackMessage>()
{
  return "grbl_msgs/action/SendGcodeFile_FeedbackMessage";
}

template<>
struct has_fixed_size<grbl_msgs::action::SendGcodeFile_FeedbackMessage>
  : std::integral_constant<bool, has_fixed_size<grbl_msgs::action::SendGcodeFile_Feedback>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<grbl_msgs::action::SendGcodeFile_FeedbackMessage>
  : std::integral_constant<bool, has_bounded_size<grbl_msgs::action::SendGcodeFile_Feedback>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<grbl_msgs::action::SendGcodeFile_FeedbackMessage>
  : std::true_type {};

}  // namespace rosidl_generator_traits


namespace rosidl_generator_traits
{

template<>
struct is_action<grbl_msgs::action::SendGcodeFile>
  : std::true_type
{
};

template<>
struct is_action_goal<grbl_msgs::action::SendGcodeFile_Goal>
  : std::true_type
{
};

template<>
struct is_action_result<grbl_msgs::action::SendGcodeFile_Result>
  : std::true_type
{
};

template<>
struct is_action_feedback<grbl_msgs::action::SendGcodeFile_Feedback>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits


#endif  // GRBL_MSGS__ACTION__DETAIL__SEND_GCODE_FILE__TRAITS_HPP_
